# Generated by Django 2.2.18 on 2021-10-21 19:04

import canvas.models.sync
from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone
import enumfields.fields
import shuup.core.fields
import shuup.core.pricing


class Migration(migrations.Migration):

    dependencies = [
        ('shuup', '0093_fix_attr_m2m'),
        ('canvas', '0019_syncedcontact'),
    ]

    operations = [
        migrations.CreateModel(
            name='StorePurchase',
            fields=[
                ('syncedobject_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='canvas.SyncedObject')),
                ('created_on', models.DateTimeField(auto_now=True, db_index=True, verbose_name='created on')),
                ('modified_on', models.DateTimeField(auto_now=True, db_index=True, verbose_name='modified on')),
                ('reference_number', models.CharField(db_index=True, max_length=64, verbose_name='reference number')),
                ('currency', shuup.core.fields.CurrencyField(max_length=4, verbose_name='currency')),
                ('taxful_total_price_value', shuup.core.fields.MoneyValueField(decimal_places=9, default=0, editable=False, max_digits=36, verbose_name='grand total')),
                ('taxless_total_price_value', shuup.core.fields.MoneyValueField(decimal_places=9, default=0, editable=False, max_digits=36, verbose_name='taxless total')),
                ('customer', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, related_name='store_purchases', to='shuup.Contact', verbose_name='customer')),
                ('shop', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='store_purchases', to='shuup.Shop')),
                ('store', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='store_purchases', to='shuup.Supplier')),
            ],
            options={
                'abstract': False,
            },
            bases=('canvas.syncedobject',),
        ),
        migrations.AlterField(
            model_name='syncedobject',
            name='square_id',
            field=models.CharField(help_text="Square's identifier for the record (unknown till after upsert)", max_length=200, null=True),
        ),
        migrations.CreateModel(
            name='StorePurchaseLine',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('type', enumfields.fields.EnumIntegerField(default=1, enum=canvas.models.sync.StorePurchaseLineType, verbose_name='line type')),
                ('quantity', shuup.core.fields.QuantityField(decimal_places=9, default=1, max_digits=36, verbose_name='quantity')),
                ('base_unit_price_value', shuup.core.fields.MoneyValueField(decimal_places=9, default=0, max_digits=36, verbose_name='unit price amount (undiscounted)')),
                ('discount_amount_value', shuup.core.fields.MoneyValueField(decimal_places=9, default=0, max_digits=36, verbose_name='total amount of discount')),
                ('created_on', models.DateTimeField(auto_now_add=True, db_index=True, verbose_name='created on')),
                ('modified_on', models.DateTimeField(db_index=True, default=django.utils.timezone.now, editable=False, verbose_name='modified on')),
                ('accounting_identifier', models.CharField(blank=True, max_length=32, verbose_name='accounting identifier')),
                ('order', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='lines', to='canvas.StorePurchase')),
                ('parent_line', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, related_name='child_lines', to='canvas.StorePurchaseLine', verbose_name='parent line')),
                ('product', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, related_name='store_purchase_lines', to='shuup.Product', verbose_name='product')),
                ('supplier', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='store_purchase_lines', to='shuup.Supplier')),
            ],
            options={
                'abstract': False,
            },
            bases=(models.Model, shuup.core.pricing.Priceful),
        ),
    ]
